/***************************************************************************
                          cdb.h  -  description
                             -------------------
    begin                : Thu Jan 23 2003
    copyright            : (C) 2003 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDB_H
#define CDB_H

#include <map>
#include <string>
#include <fstream>
#include <stdexcept>
//#include "constants.h"
#include "BioSequence.h"

using namespace std;

namespace bio {
#ifndef MAXLINELENGTH 
#define MAXLINELENGTH 255
#endif
#ifndef MAXNAMESIZE 
#define MAXNAMESIZE 255
#endif
/**
  *@author Oleksiy Kohany
  */

struct CLP {
   string fname;
   size_t headPos;
   size_t dataPos;

   CLP() {
      headPos = 0;
      dataPos = 0;
   }
   CLP(const string& fn, size_t hp, size_t dp) {
      headPos = hp;
      dataPos = dp;
   }
   /** No descriptions */
   void assign(const string& fn, size_t hp, size_t dp){
      fname = fn;
      headPos = hp;
      dataPos = dp;
   }
   /** No descriptions */
   void assign(const char* fn, size_t hp, size_t dp){
      fname = fn;
      headPos = hp;
      dataPos = dp;
   }
};

ostream& operator << (ostream& os, CLP& lp);

typedef map<string, CLP> LPMAP;

class CDb {
  LPMAP lpmap;
  /**  */
  ifstream *ifs;
  /**  */
  size_t iLastPos;
  /**  */
  string sDbDir;
  /**  */
  string sDbName;
  /**  */
  string sIDX;
  /**  */
  unsigned int iIDXSize;
  /** No descriptions */
  void findLocus(const char* locus);
  /** No descriptions */
  void open_ifs(const string& fn);
  /** No descriptions */
  void close_ifs();
  /** No descriptions */
  void rewind_ifs();
  /** No descriptions */
  size_t fragment(size_t iF, size_t iT, string& sq, bool bGap=0);
  /** No descriptions */
  size_t getWidth();
  /** No descriptions */
  int loadIndexUpToDate(const char* fdb, const char* idx);
  /** No descriptions */
  int loadIdx(const char *fn);
  /** No descriptions */
  void saveIdx(const char* fn);
public: 
	CDb(const char* fname);
	~CDb();
  /** No descriptions */
  size_t getDataPos(const char* locus);
  /** No descriptions */
  size_t getHeadPos(const char* locus);
  /** No descriptions */
  void saveIdx(ostream& fn);
  /** No descriptions */
  bool exist(const char *pcFName);
  /** No descriptions */
  istream& getData(const char* locus);
  /** No descriptions */
  istream& getHead(const char* locus);
  /** No descriptions */
  size_t fragment(const char* pcName, size_t iF, size_t iT, BioSubSequence& sq, bool bGap=0);
  /** No descriptions */
  static size_t fragment(ifstream* ifs, size_t iCnt, string& sq, bool bGap=0);
  /** No descriptions */
  static size_t fragment(FILE* ifs, size_t iCnt, string& sq, bool bGap=0);
};

int cmpage(const char* name1, const char* name2);
};
#endif
